Status: Closed
Priority: Normal
Category:
Customer: TRACETRONIC Product Issue
Numbers:
Department: Affected Products: ADTF 2.14.3, ADTF File Library 0.4.1
(BETA), ADTF Streaming Library 2.9.0
Requester's Priority: Normal Platform: Windows 7 64bit
Support Level: 2nd Level Topic: ADTF::DAT
Resolution: Solved Issue FAQ Links:
Description
Supportanfrage:

Hintergrund meiner Anfrage sind geplante Erweiterungen in der Anbindung unserer Testautomatisierung ECU-TEST an ADTF. Wir
untersuchen gerade, wie wir Signale vom Messagebus aufzeichnen und diese Aufzeichnung dann in ECU-TEST einlesen und
verarbeiten kénnen.

Die erste offensichtliche Lésung wére die Aufzeichnung mit dem Harddisk-Rekorder und das Einlesen und Verarbeiten der erstellten
DAT-Files. Bzgl. diesem Ansatz habe ich folgende Fragen:

1. Kannst du mir zu den Bibliotheken fur den DAT-Zugriff ein paar Eckdaten geben:

- Welche Bibliotheken gibt es fur den DAT-Zugriff (Ich habe von Streaming Library und ADTF DAT File gelesen. Mir ist aber
nicht klar, was sich dahinter verbirgt, was man wann verwenden sollte bzw. ob es noch andere gibt)?

- Wie und von wem werden die Bibliotheken distributiert (sind diese z.B. Teil der ADTF-Installation)?

Welche Lizenzbedingungen gelten fur die Bibliotheken und ggf. deren Abh&ngigkeiten?

UnterstUtzt die Bibliothek flir DAT-Files aus ADTF-3 auch DAT-Files aus ADTF-2?

2. Sind die bendtigten DDL-Informationen zur Extraktion der Signale bzw. Signalelemente aus den Samples in den DAT-Files
vorhanden oder missen diese separat beigestellt werden?

Als zweiten Ansatz sehe ich das Mithéren auf dem Messagebus als externe Applikation (im Handbuch meiner Meinung nach als
"ADTF-to-X communication" bezeichnet). Die externe Applikation kénnte dann in ein eigenes Format aufzeichnen. Wo kann ich Gber
das Example "dspace_autobox_connection" hinausgehende Informationen zu diesem Ansatz finden? Mich interessiert:

1. Wie kann ich die Signale und deren Samples mittels Out-Port aus ADTF heraus leiten?

2. Welches Protokoll ist von der externen Applikation fiir den Datenempfang zu beachtende?

3. Enthalten die empfangenen Samples die gleichen ADTF-Zeitstempel, die auch der Harddisk-Rekorder in die DAT-Files
schreiben wirde.

4. Kann ich das Starten/Stoppen/Pausieren bzw. das Neustarten der ADTF-Konfiguration erkennen?

Viele GriiBe und einen schénen Feiertag
Thomas

P.S. Meine Fragen beziehen sich (wo nicht explizit genannt) immer auf ADTF 2, da alle unsere Kunden bisher noch die alte Version
verwenden.

Lésung:

Siehe Kommentare
History

#1 - 2019-05-31 09:51 - hidden

- Project changed from Public Support to 28

- Status changed from New to In Progress

- Topic set to ADTF::DAT

- Customer set to TRACETRONIC

- Affected Products ADTF 2.14.3, ADTF File Library 0.4.1 (BETA), ADTF Streaming Library 2.9.0 added

#2 - 2019-05-31 10:31 - hidden
- File adtf_streaming_library _license.txt added
Hallo Thomas,
zum ersten Teil deiner Anfrage:
- Welche Bibliotheken gibt es fur den DAT-Zugriff (Ich habe von Streaming Library und ADTF DAT File gelesen. Mir ist aber nicht klar, was sich

dahinter verbirgt, was man wann verwenden sollte bzw. ob es noch andere gibt)?

In unserem Downloadbereich findest Du unter Overview of Products and Documentation die ADTF Streaming Library fir ADTF 2.x .dat files und die
ADTF File Library (IFHD)fur ADTF 3.x .adtfdat files.
Hier sind auch die Dokus und Informationen zu den beiden Anwendungen hinterlegt.

z.b. Auszug aus der Doku der ADTF Streaming Library:
The ADTF Streaming Library is used for read and write access to files compatible to the
ADTF Harddisk Recorder, so called DAT Files. The Streaming Library allows you loading
DAT Files, selecting a single or all Streams in the DAT File and reading the saved data thereof.
It also allows you to create new DAT Files an to populate them with data.
- Wie und von wem werden die Bibliotheken distributiert (sind diese z.B. Teil der ADTF-Installation)?
Die beiden Anwendungen sind eigenstandig und benétigen kein ADTF.
Requirements fiir die ADTF File Library sind in der Download Ubersicht mit aufgeftihrt.
Beide kénnen dort heruntergeladen werden.

- Welche Lizenzbedingungen gelten fur die Bibliotheken und ggf. deren Abhangigkeiten?

Die Lizenz Info der ADTF Streaming Library habe ich als Anhang hinzugefiigt.
Die ADTF File Library lauft unter MPL 2.0 Siehe hierzu direkt in der Doku: License Information

- Unterstitzt die Bibliothek fir DAT-Files aus ADTF-3 auch DAT-Files aus ADTF-2?

Ja, die ADTF File Library kann auch ADTF 2.x DAT files verarbeiten.
2. Sind die benétigten DDL-Informationen zur Extraktion der Signale bzw. Signalelemente aus den Samples in den DAT-Files vorhanden oder
muissen diese separat beigestellt werden?

Diese mussen bei der Aufnahme mit dem HD Recoder mit erstellt werden in der Media Description. Dazu musst man bei der Aufnahme im Recorder

Create Media Description auf true setzen, dann entsteht neben dem .dat File auch ein .dat.description File.

@°Frank: Kannst Du bitte zum zweiten Teil der Anfrage Informationen geben!?

#5 - 2019-06-14 10:38 - hidden

Hallo Thomas,

zu Deinen Fragen:

1. Kannst du mir zu den Bibliotheken fiir den DAT-Zugriff ein paar Eckdaten geben:
- Welche Bibliotheken gibt es fiir den DAT-Zugriff (Ich habe von Streaming Library und ADTF DAT File gelesen. Mir ist aber nicht klar, was sich
dahinter verbirgt, was man wann verwenden sollte bzw. ob es noch andere gibt)?

Far die Verarbeitung von ADTF DAT-Files gibt es fur ADTF2 die Streaming Library.

Wenn mit ADTF2 eine Datei mit Hilfe des Harddisk-Rekorders aufgezeichnet wird, entsteht eine sog. DAT-Datei. Diese DAT-Datei beinhaltet
Datenstréme (Streams). Jeder Datenstrom reprasentiert dabei einen Pin am Harddisk-Rekorder. Als Alternative kann hierbei auch der Nachfolger der
Streaming Library, die File Library werdet werden. Diese unterstltzt neben den DAT-Files vom ADTF3 auch die DAT-Files der ADTF2 Variante.

- Wie und von wem werden die Bibliotheken distributiert (sind diese z.B. Teil der ADTF-Installation)?
Diese Bibliotheken sind nicht Teil der ADTF-Installation, kdnnen jedoch von unserer Support-Seite heruntergeladen werden.

- Welche Lizenzbedingungen gelten fur die Bibliotheken und ggf. deren Abh&ngigkeiten?
Fir die Bibliotheken gibt es keine besonderen Lizenzbedingungen, da diese "Stand-Alone" sind.

- Unterstitzt die Bibliothek fir DAT-Files aus ADTF-3 auch DAT-Files aus ADTF-2?
Ja, die ADTF File Library unterstiitzt beide Formate.

2. Sind die bendtigten DDL-Informationen zur Extraktion der Signale bzw. Signalelemente aus den Samples in den
DAT-Files vorhanden oder miissen diese separat beigestellt werden?

Bei ADTF2 mussen passende Description-Files mit den DDL-Informationen zum DAT-File separat dazugelegt werden.
Bei ADTF3 ist das nicht mehr notwendig, da die DDL-Beschreibung bereits im DAT-File vorhanden ist.

Als zweiten Ansatz sehe ich das Mithéren auf dem Messagebus als externe Applikation (im Handbuch meiner Meinung nach als "ADTF-to-X
communication" bezeichnet). Die externe Applikation kénnte dann in ein eigenes Format aufzeichnen. Wo kann ich tber das Example
"dspace_autobox_connection" hinausgehende Informationen zu diesem Ansatz finden?

In der SDK-Dokumentation gibt es noch zwei weitere Anlaufpunkte:

1. ADTF --> ADTF Tools --> ADTF Launcher Environment (adtf_launcher) --> The ADTF Filtergraph Manager Plugin --> Filtergraph Manager
Service --> ADTF FilterGraph Manager uses the Message Bus Service

2. ADTF --> ADTF Plugin SDK Documentation --> ADTF Examples --> Additional examples --> Demo ADTF external data exchange
communication

1. Wie kann ich die Signale und deren Samples mittels Out-Port aus ADTF heraus leiten?
Hierfir sollte der MessageBus verwendet werden.

2. Welches Protokoll ist von der externen Applikation ftir den Datenempfang zu beachtende?

Um die Datenstrome von der externen Applikation richtig zu interpretieren, kénnen Header-Files generiert werden, die die DDL-Beschreibung in Form
von Strukturen beinhalten.

Diese Header-Files kénnen dann in die Applikation inkludiert und der Payload des Samples als solche interpretiert werden.

3. Enthalten die empfangenen Samples die gleichen ADTF-Zeitstempel, die auch der Harddisk-Rekorder in die DAT-Files schreiben wirde.
Ja, da in den Samples der Zeitstempel der ADTF-Streaming-Zeit, welche durch die ADTF-Clock vorgegeben wird, abgelegt ist.

4. Kann ich das Starten/Stoppen/Pausieren bzw. das Neustarten der ADTF-Konfiguration erkennen?
Die Zustande der Runtime wird leider nicht Uber das ADTF-to-X Modell Ubertragen, es erfolgt nur eine reine Datentbertragung.
Die Erkennung von Laufzeitzustdnden kann nur von ADTF-Komponenten, die direkt am ADTF "dran” sind, detektiert werden.

Ich hoffe, dass ich Deine Fragen soweit beantworten konnte.

Viele GruB3e
Frank

#6 - 2019-06-14 10:39 - hidden

- Status changed from In Progress to Customer Feedback Required
#7 - 2019-06-14 11:45 - hidden
Hallo Matthias und Frank,

vielen Dank fur die Informationen zu den DAT-Bibliotheken und dem MB-Zugriff. Diese waren sehr hilfreich. Fir den aktuellen Anwendungsfall
préferieren wir die Nutzung des HDRecorders und die Verarbeitung der erzeugten DAT-Files in ECU-TEST.

Da die File Library das alte und das neue DAT-Format unterstiitzt und die Streaming Library vermutlich irgendwann mit ADTF2 ,beerdigt” wird,
scheint uns strategisch sinnvoll, auf die File Library zu setzen. Allerdings scheint die File Library (0.4.1) noch Beta-Status zu haben? Deshalb hatte
ich ein paar Anschlussfragen, um bzgl. der strategischen Entscheidung fir die File Library etwas mehr Sicherheit zu erlangen:

1)  Ist der Support fur die Library wegen des Beta-Status irgendwie eingeschrénkt?

2) Ist absehbar, wann die Bibliothek den Beta-Status verlasst?

3)  Welche Stabilitat hat die API? Wird bspw. die Abwartskompatibilitt in neuen Versionen bereits sichergestellt?

4)  Welche funktionalen Einschrankungen gibt es gegentber der Streaming Library? (Unter Umstanden weder einfach noch umfassend zu
beantworten. Aber vielleicht kdnnt ihr auf wichtige grundsétzliche Einschrankungen hinweisen, falls es denn solche gibt. Beispielsweise, wenn
bestimmte Informationen in ADTF-2-Dateien nur mit der Streaming Library ausgelesen werden kénnen. Oder wenn die Streaming Library mit
gesplitteten Aufnahmen umgehen kann, aber die File Library nicht.)

Far Antworten auf diese Fragen ware ich wieder sehr dankbar.

Viele GruB3e
Thomas

#8 - 2019-06-14 11:46 - hidden

- Status changed from Customer Feedback Required to In Progress

#9 - 2019-06-17 08:33 - hidden

- Status changed from In Progress to Customer Feedback Required

Hallo Thomas,

Da die File Library das alte und das neue DAT-Format unterstiitzt und die Streaming Library vermutlich irgendwann mit ADTF2 ,beerdigt” wird,
scheint uns strategisch sinnvoll, auf die File Library zu setzen.

Genau so sollte die Entscheidung ausfallen, langfristig betrachtet.

1) Ist der Support fiir die Library wegen des Beta-Status irgendwie eingeschrankt?
2) Ist absehbar, wann die Bibliothek den Beta-Status verlasst?

Das BETA hier kannst du ignorieren, das "muss" wegen 0.x.y Version gesetzt werden.
Du erhélst vollen Support dafur, kannst aber aufgrund der Source Code Lieferung auch selbst den Code einsehen und mitarbeiten.

3) Welche Stabilitat hat die API? Wird bspw. die Abwartskompatibilitat in neuen Versionen bereits sichergestellt?

Da die Library die Basis fur ADTF 3.x bildet, sind wir auch hier Code- und Bindrkompatibel.
Seit 0.4.0 sind die Interfaces fix, die API wird sich wenn dann nur noch erweitern.

Es gelten die gleichen Anforderungen wie an ADTF 3.x selbst.

Du wirst also alte adtffileplugins laden kdnnen, (adtf)dat files ohnehin.

4) Welche funktionalen Einschrénkungen gibt es gegenuber der Streaming Library? (Unter Umsténden weder einfach noch umfassend zu
beantworten. Aber vielleicht kdnnt ihr auf wichtige grundsétzliche Einschrankungen hinweisen, falls es denn solche gibt. Beispielsweise, wenn
bestimmte Informationen in ADTF-2-Dateien nur mit der Streaming Library ausgelesen werden kdnnen. Oder wenn die Streaming Library mit
gesplitteten Aufnahmen umgehen kann, aber die File Library nicht.)

Mir sind aktuell keine Einschrankungen bekannt.

Der Vorteil an der ADTF File Library ist auch, dass wir sie Open Source liefern, d.h. nicht nur komplette Einsicht fiir euch wie die adtfdat Welt
funktioniert, sondern ihr kdnnt sie notfalls auch selbst erweitern, anpassen oder patchen.

Durch das File Format in ADTF 3.x brauchst du auch nicht so viel Erweiterungen, da die Datenbeschreibung nun im adtfdat File bekannt ist.
Eigenimplementierte Deserilaisierungen musst du aber via adtffileplugins bekannt machen, die Basics werden von ADTF und Toolboxen (z.B. ADTF
2.x Flexray) aber geliefert.

Aber das musst du in der Streaming Library auch, wenngleich du dafiir die Services aus ADTF nutzen konntest.

Die einzige Einschrankung die mir einfallt:

Sie ist derzeit auf das Lesen von ADTF 2.x und ADTF 3.x Files ausgelegt, aber beim Schreiben fehlt im ADTF 2.x File das .dat.description File, was
aber fur euren Use nicht relevant ist.

#10 - 2019-06-18 09:08 - hidden

Kann das Ticket damit geschlossen werden?
Bitte gib uns Feedback bis 21.06.2019

#11 - 2019-06-18 09:30 - hidden

Hallo Florian und Michael,

vielen Dank fur die schnelle Reaktion und die detaillierten Antworten. Das Ticket ist damit erledigt und kann geschlossen werden. Bei eventuell
aufkommenden Fragen wéhrend der nun anstehende Implementierung erstelle ich ein neues Ticket.

Viele GruB3e
Thomas Lohse
#12 - 2019-06-25 14:57 - hidden

- Description updated

- Status changed from Customer Feedback Required to To Be Closed
- Resolution set to Solved Issue

- Platform Windows 7 64bit added

#13 - 2019-07-19 08:23 - hidden

- Project changed from 28 to Public Support

- Subject changed from Verarbeitung von ADTF-DAT-Files / Aufzeichnen von ADTF-Signalen to Processing dat files
- Status changed from To Be Closed to Closed

- Private changed from Yes to No

Files

adtf_streaming_library_license.txt 2.25 KB 2019-05-31 hidden

2024-04-18 5/5


http://www.tcpdf.org

